
#include "stdafx.h"
#include <winioctl.h>
#include "HE_Drives.h"

bool GetSectorData( pHEDriveInfo pDrvInfo, long sector, BYTE* buf )
{
	HANDLE hDevice= CreateFile(
		pDrvInfo->strPhysicalName,
		GENERIC_READ | GENERIC_WRITE,
		FILE_SHARE_READ | FILE_SHARE_WRITE,
		0,
		OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL | FILE_FLAG_OVERLAPPED,
		0
	);
	if( hDevice == INVALID_HANDLE_VALUE )
		return false;

	OVERLAPPED ol;
	memset( &ol, 0, sizeof( OVERLAPPED ) );
	ol.Offset= sector * 512;

	DWORD get= 512;
	DWORD read;
	BOOL bRead= ReadFile( hDevice, buf, get, &read, &ol );
	long err= GetLastError( );

	//wait for transfer
    if( ! GetOverlappedResult( hDevice, &ol, &read, TRUE ) )
		ASSERT( false );

	err= GetLastError( );
	CloseHandle( hDevice );
	return true;
}

bool SetSectorData( pHEDriveInfo pDrvInfo, long sector, BYTE* buf )
{
	HANDLE hDevice= CreateFile(
		pDrvInfo->strPhysicalName,
		GENERIC_READ | GENERIC_WRITE,
		FILE_SHARE_READ | FILE_SHARE_WRITE,
		0,
		OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL | FILE_FLAG_OVERLAPPED,
		0
	);
	if( hDevice == INVALID_HANDLE_VALUE )
		return false;

	OVERLAPPED ol;
	memset( &ol, 0, sizeof( OVERLAPPED ) );
	ol.Offset= sector * 512;

	DWORD get= 512;
	DWORD read;
	BOOL bRead= WriteFile( hDevice, buf, get, &read, &ol );

	long err= GetLastError( );

	//wait for transfer
	if( ! GetOverlappedResult( hDevice, &ol, &read, TRUE ) )
		ASSERT( false );

	err= GetLastError( );
	CloseHandle( hDevice );
	return true;
}

void EnumDrives( HEDriveInfoSet& inSet )
{
	TCHAR nb[ 512 ];

	//Get the logical list...
	BOOL bTest= GetLogicalDriveStrings( 512, nb );

	if( ! bTest )
		return; //TODO report error

	inSet.clear( );

	for( TCHAR* p= nb; *p != _T('\0'); )
	{
		HEDriveInfo he_info;
		he_info.strDriveName= p;
		
		CString strLD( p );
		DWORD serNum;
		DWORD compLength;
		DWORD fsFlags;
		TCHAR nameBuf[ MAX_PATH ];
		TCHAR fileSysType[ MAX_PATH ];
		BOOL bDInfo= GetVolumeInformation( strLD, nameBuf, MAX_PATH, &serNum, &compLength, &fsFlags, fileSysType, MAX_PATH );
		strLD.Delete( strLD.GetLength( ) - 1 );
		he_info.strLogicalName= strLD;

		if( bDInfo )
		{
			he_info.strDriveName= nameBuf;
			he_info.dwSerial= serNum;
			he_info.strFSType= fileSysType;
		}
		else
		{
			for( ; *p; ++p )
				;
			++p;
			continue;
		}
		CString strLName;
		strLName.Format( _T("\\\\.\\\\%s"), strLD );

		HANDLE hDevice= CreateFile(
			strLName,
			GENERIC_READ | GENERIC_WRITE,
			FILE_SHARE_READ | FILE_SHARE_WRITE,
			0,
			OPEN_EXISTING,
			FILE_ATTRIBUTE_NORMAL,
			0
		);

		if( hDevice != INVALID_HANDLE_VALUE )
		{
			DWORD dwRet;
			STORAGE_DEVICE_NUMBER sd;
			bTest= DeviceIoControl(
				hDevice,
				IOCTL_STORAGE_GET_DEVICE_NUMBER,
				NULL,
				0,
				&sd,
				sizeof(STORAGE_DEVICE_NUMBER),
				&dwRet,
				NULL
			);
			
			if( bTest )
			{
				he_info.strPhysicalName.Format( _T("\\\\.\\PhysicalDrive%d"), sd.DeviceNumber );
			}
			CloseHandle( hDevice );
			inSet.push_back( he_info );
		}
		for( ; *p; ++p )
			;
		++p;
	}//for(...)
}

