/*
Secure Digital Card Interface for the MSP430
written by
F. Foust
Dept. of Electrical and Computer Engineering
Michigan State University, 2004
*/


#define SS_PORT_DIR P5DIR
#define SS_PORT_OUT P5OUT
#define SS_PIN		BIT4

#define SPI_PORT_SEL	P5SEL
#define SPI_PINS_SEL	( BIT1 | BIT2 | BIT3 )

#define SD_UCTL		U1CTL
#define SD_UTCTL	U1TCTL
#define SD_UBR0		U1BR0
#define SD_UBR1		U1BR1
#define SD_UMCTL	U1MCTL
#define MOD_REG		ME2
#define SD_USPIE	USPIE1
#define SPI_IFG		IFG2
#define SD_UTXIFG	UTXIFG1
#define SD_URXIFG	URXIFG1
#define SD_UTXBUF	U1TXBUF
#define SD_URXBUF	U1RXBUF

void spi_initialize();
void spi_set_divisor(unsigned int divisor);
void spi_cs_assert();
void spi_cs_deassert();
void spi_send_byte(unsigned char input);
unsigned char spi_rcv_byte();
void spi_enable();
void spi_disable();

